CREATE DATABASE empresa;

USE empresa;

#
# Estrutura da tabela usuarios:
#

CREATE TABLE usuarios (
  codigo int(11) NOT NULL, usuario varchar(20) default NULL,
  senha varchar(20) default NULL, nome varchar(50) default NULL,
  grupo_acesso int(11) default '0', ativo char(1) default 'S',
  PRIMARY KEY  (codigo), KEY usuario (usuario)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

#
# Dados da tabela usuarios:
#

INSERT INTO usuarios (codigo, usuario, senha, nome, grupo_acesso, ativo) VALUES
  (0,'admin','admin',NULL,0,'S');

COMMIT;

#
# Estrutura da tabela grupos_acesso:
#

CREATE TABLE grupos_acesso (
  codigo int(11) NOT NULL, descricao varchar(40) default NULL,
  PRIMARY KEY  (codigo), KEY descricao (descricao)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

#
# Dados da tabela grupos_acesso:
#

INSERT INTO grupos_acesso (codigo, descricao) VALUES
  (0,'Super Usurio');

COMMIT;

#
# Estrutura da tabela rotinas:
#

CREATE TABLE rotinas (
  nome_item_menu varchar(100) NOT NULL, ordem int(11) default NULL,
  nivel1 varchar(100) default NULL, nivel2 varchar(100) default NULL,
  nivel3 varchar(100) default NULL, action char(1) default NULL,
  nome_action varchar(20) default NULL,
  PRIMARY KEY  (nome_item_menu), KEY ordem (ordem)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

#
# Estrutura da tabela acesso_rots:
#

CREATE TABLE acesso_rots (
  grupo_acesso int(11) NOT NULL, rotina varchar(100) NOT NULL,
  executar char(1) default NULL, incluir char(1) default NULL,
  alterar char(1) default NULL, excluir char(1) default NULL,
  PRIMARY KEY  (grupo_acesso,rotina)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

#
# Estrutura da tabela codigos:
#

CREATE TABLE codigos (
  descricao varchar(20) NOT NULL, valor int(11) default '0',
  PRIMARY KEY  (descricao)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

