unit uAcesso;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Data.DB, Datasnap.DBClient,
  Vcl.StdCtrls, Vcl.Buttons, Vcl.Grids, Vcl.DBGrids, Vcl.DBCtrls;

type
  TfrmAcesso = class(TForm)
    dbtGrpAcesso: TDBText;
    dbgAcesso: TDBGrid;
    bGravar: TBitBtn;
    bCancelar: TBitBtn;
    cdsDefAcesso: TClientDataSet;
    dsDefAcesso: TDataSource;
    cdsDefAcessogrupo_acesso: TIntegerField;
    cdsDefAcessorotina: TStringField;
    cdsDefAcessonivel1: TStringField;
    cdsDefAcessonivel2: TStringField;
    cdsDefAcessonivel3: TStringField;
    cdsDefAcessoaction: TStringField;
    cdsDefAcessoexecutar: TStringField;
    cdsDefAcessoincluir: TStringField;
    cdsDefAcessoalterar: TStringField;
    cdsDefAcessoexcluir: TStringField;
    procedure FormCreate(Sender: TObject);
    procedure bCancelarClick(Sender: TObject);
    procedure bGravarClick(Sender: TObject);
    procedure dbgAcessoCellClick(Column: TColumn);
    procedure dbgAcessoDrawColumnCell(Sender: TObject; const Rect: TRect;
      DataCol: Integer; Column: TColumn; State: TGridDrawState);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
    function GeraAcesso(GrpAcesso : Integer) : Boolean;
    function AtualizaAcesso(GrpAcesso : Integer) : Boolean;
  public
    { Public declarations }
  end;

var
  frmAcesso: TfrmAcesso;

implementation

{$R *.dfm}

uses udmPrincipal, uGrpAcesso;

function TfrmAcesso.AtualizaAcesso(GrpAcesso: Integer): Boolean;
var
  vSQLd, vSQLi : String;
begin
  Result := True;
  Try
// Nesta instruo sql deletamos (se existir) na tabela acesso_rots todas as rotinas que
// no existem mais na tabela rotinas para o grupo de acesso selecionado
    vSQLd := 'delete from '+
               'acesso_rots '+
             'where '+
               'grupo_acesso = '+IntToStr(GrpAcesso)+' and rotina in ('+
             'select * from ('+
             'select '+
               'acesso_rots.rotina '+
             'from '+
               'acesso_rots '+
               'left join rotinas on (acesso_rots.rotina=rotinas.nome_item_menu) '+
             'where '+
               'acesso_rots.grupo_acesso = 1 and rotinas.nome_item_menu is null) as x)';
    dmPrincipal.sqlcEmpresa.ExecuteDirect(vSQLd);

// Nesta instruo sql inserimos na tabela acesso_rots todas as rotinas que
// foram acrescentadas na tabela rotinas (se existirem) para o grupo de acesso selecionado
    vSQLi := 'insert into acesso_rots (grupo_acesso, rotina, executar) '+
             'select '+
               IntToStr(GrpAcesso)+', rotinas.nome_item_menu, ''N'' '+
             'from '+
               'rotinas '+
               'left join acesso_rots on (acesso_rots.rotina=rotinas.nome_item_menu and '+
                                         'acesso_rots.grupo_acesso='+IntToStr(GrpAcesso)+') '+
             'where '+
               'acesso_rots.grupo_acesso is null';
    dmPrincipal.sqlcEmpresa.ExecuteDirect(vSQLi);
  Except
    Result := False;
  End;
end;

procedure TfrmAcesso.bCancelarClick(Sender: TObject);
begin
  cdsDefAcesso.CancelUpdates;
  Close; // Caso o boto cancelar seja clicado, cancelo todas as alteraes.
end;

procedure TfrmAcesso.bGravarClick(Sender: TObject);
begin
  cdsDefAcesso.ApplyUpdates(0);
  Close;  // Caso o boto gravar seja clicado, aplico todas as alteraes.
end;

procedure TfrmAcesso.dbgAcessoCellClick(Column: TColumn);
var
  wReg : Integer;
  wCmp : TField;
  wVlr : String;
begin
// no evento OnDrawColumnCell executo uma rotina que no lugar de S ou N ir
// aparecer um checkbox que ao clicar, esta rotina ir promover as mudanas
// no campo clicado (executar, incluir, alterar ou excluir)

// Aqui eu impeo a rotina ser executada caso seja clicado em um campo diferente
// de executar, incluir, alterar ou excluir e de alterar a opo Sair j que
// qualquer usurio pelo menos tenha o direito de sair do aplicativo
  If (Column.Index < 3) or (cdsDefAcessonivel1.AsString = 'Sair') Then Exit;
  wCmp := Column.Field;
  cdsDefAcesso.Edit;
  if wCmp.AsString = 'S' then
    wCmp.AsString := 'N'
  else
    wCmp.AsString := 'S';
  cdsDefAcesso.Post;

// A partir daqui executo uma rotina que verificar se a opo clicada  um item
// que d acesso a um form do aplicativo ou  apenas um sub menu ou um sub item
// e ento a rotina ir marcar para aquele campo a alterao em todos os items ou
// sub itens a seguir.
  If cdsDefAcessonivel3.AsString <> '' Then Exit;

  wVlr := wCmp.AsString;
  wReg := cdsDefAcesso.RecNo;
  cdsDefAcesso.DisableControls;
  If cdsDefAcessonivel1.AsString <> '' Then
  Begin
    cdsDefAcesso.Next;
    While (not cdsDefAcesso.Eof) and (cdsDefAcessonivel1.AsString = '') Do
    Begin
      cdsDefAcesso.Edit;
      wCmp.AsString := wVlr;
      cdsDefAcesso.Post;
      cdsDefAcesso.Next;
    End;
  End;
  If cdsDefAcessonivel2.AsString <> '' Then
  Begin
    cdsDefAcesso.Next;
    While (not cdsDefAcesso.Eof) and (cdsDefAcessonivel2.AsString = '')
                           and (cdsDefAcessonivel3.AsString <> '') Do
    Begin
      cdsDefAcesso.Edit;
      wCmp.AsString := wVlr;
      cdsDefAcesso.Post;
      cdsDefAcesso.Next;
    End;
  End;
  cdsDefAcesso.RecNo := wReg;
  cdsDefAcesso.EnableControls;
end;

procedure TfrmAcesso.dbgAcessoDrawColumnCell(Sender: TObject; const Rect: TRect;
  DataCol: Integer; Column: TColumn; State: TGridDrawState);
var
  Check: Integer;
  R : TRect;
begin
//Desenha um checkbox no dbgrid
  If Column.Index < 3 Then Exit;
  dbgAcesso.Canvas.FillRect(Rect);
  Check := 0;
  if Column.Field.AsString = 'S' then
    Check := DFCS_CHECKED
  else
    Check := 0;
  R:=Rect;
  InflateRect(R,-2,-2); {Diminue o tamanho do CheckBox}
  DrawFrameControl(dbgAcesso.Canvas.Handle,R,DFC_BUTTON, DFCS_BUTTONCHECK or Check);
end;

procedure TfrmAcesso.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  cdsDefAcesso.Close;
end;

procedure TfrmAcesso.FormCreate(Sender: TObject);
var
  wGrpAcesso : Integer;
begin
  wGrpAcesso := frmGrpAcesso.cdsCadscodigo.AsInteger;
// Aqui eu seleciono todos os acessos as rotinas definidos para
// o grupo de acesso selecionado
  cdsDefAcesso.Params[0].AsInteger := wGrpAcesso;
  cdsDefAcesso.Open;
  If cdsDefAcesso.RecordCount = 0 Then
  Begin
// Caso seja um grupo de acesso, executo a funo para gerar os acessos para configurao
    If not GeraAcesso(wGrpAcesso) Then
    Begin
      MessageDlg('Erro ao Tentar Gerar a Definio de Acessos!!!',
                 mtError, [mbOK], 0);
      Tag := 1;
    End;
  End
  Else
  Begin
// Caso j existam acessos definidos, executo a funo para verificar se existem
// Acessos que no existem mais e exclu-los e verificar se existem novas rotinas
// para inclu-las nos acessos a serem configurados.
    If not AtualizaAcesso(wGrpAcesso) Then
    Begin
      MessageDlg('Erro ao Tentar Atualizar a Definio de Acessos!!!',
                 mtError, [mbOK], 0);
      Tag := 1;
    End;
  End;
// executo um refresh para caso haja alteraes, o clientdataset seja atualizado
  cdsDefAcesso.Refresh;
  cdsDefAcesso.Last; // vou para o ultimo acesso (Sair da aplicao)
  cdsDefAcesso.Edit; // defino que pode executar pelo menos sair da aplicao
  cdsDefAcessoexecutar.AsString := 'S';
  cdsDefAcesso.Post;
  cdsDefAcesso.First;
end;

function TfrmAcesso.GeraAcesso(GrpAcesso: Integer): Boolean;
var
  vSQL : String;
begin
  Result := True;
  Try
// Nesta instruo sql inserimos na tabela acesso_rots todas as rotinas para
// o grupo de acesso selecionado
    vSQL := 'insert into acesso_rots (grupo_acesso, rotina) '+
            'select '+
               IntToStr(GrpAcesso)+', nome_item_menu '+
            'from '+
              'rotinas ';
    dmPrincipal.sqlcEmpresa.ExecuteDirect(vSQL);
  Except
    Result := False;
  End;
end;

end.
