unit uCads;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls, Vcl.Grids, Vcl.DBGrids,
  Data.DB, Datasnap.DBClient, Vcl.StdCtrls, Vcl.Buttons, Vcl.Mask, Vcl.DBCtrls;

type
  TfrmCads = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    eFiltro: TEdit;
    dbeCodigo: TDBEdit;
    dbeDescricao: TDBEdit;
    bCancPesq: TBitBtn;
    cdsCads: TClientDataSet;
    dsCads: TDataSource;
    dbgCads: TDBGrid;
    Panel1: TPanel;
    bSair: TBitBtn;
    bPrimeiro: TBitBtn;
    bUltimo: TBitBtn;
    bPesq: TBitBtn;
    bNovo: TBitBtn;
    bAlterar: TBitBtn;
    bExcluir: TBitBtn;
    bGravar: TBitBtn;
    bCancelar: TBitBtn;
    procedure bAlterarClick(Sender: TObject);
    procedure bCancelarClick(Sender: TObject);
    procedure bCancPesqClick(Sender: TObject);
    procedure bExcluirClick(Sender: TObject);
    procedure bGravarClick(Sender: TObject);
    procedure bNovoClick(Sender: TObject);
    procedure bPesqClick(Sender: TObject);
    procedure bPrimeiroClick(Sender: TObject);
    procedure bSairClick(Sender: TObject);
    procedure bUltimoClick(Sender: TObject);
    procedure dbgCadsDblClick(Sender: TObject);
    procedure dsCadsDataChange(Sender: TObject; Field: TField);
    procedure dsCadsStateChange(Sender: TObject);
    procedure eFiltroChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    uCodigo : TIntegerField;   //objetos a serem utilizados em pesquisas
    uDescricao : TStringField; // a partir de outros forms
    uIncluir, uAlterar, uExcluir : String;  // variveis utilizadas para
  end;                                      // definir acesso do usurio logado.

var
  frmCads: TfrmCads;

implementation

uses udmPrincipal; // declarao para utilizar recursos de dmPrincipal

{$R *.dfm}

procedure TfrmCads.bAlterarClick(Sender: TObject);
begin
  cdsCads.Edit;
  dbeDescricao.SetFocus;
end;

procedure TfrmCads.bCancelarClick(Sender: TObject);
begin
  cdsCads.Cancel;
end;

procedure TfrmCads.bCancPesqClick(Sender: TObject);
begin
  bCancPesq.Visible := False;
  cdsCads.Close;    // Aqui definimos que o parmetro receber % para que mostre
  cdsCads.Params[0].AsString := '%';  // todos os registros do select
  cdsCads.Open;
  eFiltro.Enabled := True;
  bPesq.Visible := True;
end;

procedure TfrmCads.bExcluirClick(Sender: TObject);
begin
  If MessageDlg('Tem certeza que quer Excluir Definitivamente este REGISTRO???',
         mtConfirmation, [mbYes, mbNo], 0, mbNo) = mrYes Then Begin
    cdsCads.Delete;
    cdsCads.ApplyUpdates(0);
  End;
end;

procedure TfrmCads.bGravarClick(Sender: TObject);
begin
  cdsCads.Post;
  cdsCads.ApplyUpdates(0);
end;

procedure TfrmCads.bNovoClick(Sender: TObject);
begin
  cdsCads.Insert;
  dbeDescricao.SetFocus;
end;

procedure TfrmCads.bPesqClick(Sender: TObject);
begin
  bPesq.Visible := False;
  eFiltro.Enabled := False;
  cdsCads.Close;  // aqui habilitamos o filtro com o conteudo de eFiltro
  cdsCads.Params[0].AsString := '%'+eFiltro.Text+'%';
  cdsCads.Open;
  bCancPesq.Visible := True;
end;

procedure TfrmCads.bPrimeiroClick(Sender: TObject);
begin
  cdsCads.First;
end;

procedure TfrmCads.bSairClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmCads.bUltimoClick(Sender: TObject);
begin
  cdsCads.Last;
end;

procedure TfrmCads.dbgCadsDblClick(Sender: TObject);
begin
  If (dsCads.State in [dsInsert, dsEdit]) or (Tag = 0) Then Exit;
  If not cdsCads.IsEmpty Then Begin
    uCodigo.AsInteger := cdsCads.FieldByName('codigo').AsInteger;
    uDescricao.AsString := cdsCads.FieldByName('descricao').AsString;
  End; // aqui ser passado o resultado de uma escolha para um outro form
  Tag := 0; // quando setado o Tag = 1 e se no estiver em modo
  Close;    // de Insert ou Edit
end;

procedure TfrmCads.dsCadsStateChange(Sender: TObject);
begin
  // bNovo ficara habilidado se estiver no estiver em modo de Insert ou Edit
  // e se o usurio possuir direito para Inserir dados no referido form.
  bNovo.Enabled := (not (dsCads.State in [dsInsert, dsEdit])) and (uIncluir = 'S');
  // bAlterar = o mesmo que bNovo e se houver dados na tabela daquele form
  // sem poder alterar qualquer registro com cdigo=0 (grupo de acesso Super Usurio)
  bAlterar.Enabled := (not (dsCads.State in [dsInsert,dsEdit])) and (not dsCads.DataSet.IsEmpty) and (uAlterar = 'S')
                       and (cdsCads.FieldByName('codigo').AsInteger <> 0);
  // bSair somente se no estiver em estado de Insert ou Edit
  bSair.Enabled := not (dsCads.State in [dsInsert, dsEdit]);
  // bExcluir = o mesmo que bAlterar
  bExcluir.Enabled := (not (dsCads.State in [dsInsert,dsEdit])) and (not dsCads.DataSet.IsEmpty) and (uExcluir = 'S')
                       and (cdsCads.FieldByName('codigo').AsInteger <> 0);
  // bGravar somente se estiver em modo de Insert ou Edit
  bGravar.Enabled := dsCads.State in [dsInsert,dsEdit];
  // bCancelar = bGravar
  bCancelar.Enabled := bGravar.Enabled;
  // o Grid s estar habilitado se no estiver em modo de Insert ou Edit
  dbgCads.Enabled := (not bGravar.Enabled);
end;

procedure TfrmCads.eFiltroChange(Sender: TObject);
begin
  bPesq.Visible := Length(eFiltro.Text) > 3;
end;

procedure TfrmCads.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  cdsCads.Close;
end;

procedure TfrmCads.FormCreate(Sender: TObject);
begin
  cdsCads.Params[0].AsString := '%';
  cdsCads.Open;
end;

procedure TfrmCads.dsCadsDataChange(Sender: TObject; Field: TField);
begin
  bPrimeiro.Enabled := not ((cdsCads.Bof) or (cdsCads.IsEmpty) or
                            (dsCads.State in [dsInsert, dsEdit]));
  bUltimo.Enabled := not ((cdsCads.Eof) or (cdsCads.IsEmpty) or
                           (dsCads.State in [dsInsert, dsEdit]));
  dsCadsStateChange(nil);
end;

end.
