unit uLogin;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls, Vcl.StdCtrls;

type
  TfrmLogin = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    eUsuario: TEdit;
    eSenha: TEdit;
    bLogar: TButton;
    bCancelar: TButton;
    Image1: TImage;
    procedure bCancelarClick(Sender: TObject);
    procedure eUsuarioChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure bLogarClick(Sender: TObject);
  private
    { Private declarations }
    Tentativas : Integer;
  public
    { Public declarations }
  end;

var
  frmLogin: TfrmLogin;

implementation

{$R *.dfm}

uses udmPrincipal;

procedure TfrmLogin.bCancelarClick(Sender: TObject);
begin
  dmPrincipal.FechaBanco;
  Application.Terminate;
end;

procedure TfrmLogin.bLogarClick(Sender: TObject);
begin
  dmPrincipal.cdsLogin.Close;
  dmPrincipal.cdsLogin.Params[0].AsString := Trim(eUsuario.Text);
  dmPrincipal.cdsLogin.Open;

  If dmPrincipal.cdsLogin.IsEmpty Then Begin
    MessageDlg('No existe usurio com este nome de login!!!', mtInformation, [mbOK], 0);
    eUsuario.SetFocus;
    Exit;
  End;

  If dmPrincipal.cdsLoginativo.AsString <> 'S' Then Begin
    MessageDlg('Usurio inativo!!! Entre em contato com o suporte.', mtInformation, [mbOK], 0);
    eUsuario.SetFocus;
    Exit;
  End;

  If eSenha.Text <> dmPrincipal.cdsLoginsenha.AsString Then Begin
    MessageDlg('Senha invlida!!!', mtInformation, [mbOK], 0);
    Inc(Tentativas);
    If Tentativas = 3 Then
      bCancelarClick(nil);
    eSenha.SetFocus;
    eSenha.SelectAll;
    Exit;
  End;

  Tag := 1;
  Close;
end;

procedure TfrmLogin.eUsuarioChange(Sender: TObject);
begin
  bLogar.Enabled := Length(Trim(eUsuario.Text)) > 0; // ativa o boto Logar apenas se tiver um ou mais
                                                     // caracteres digitados
end;

procedure TfrmLogin.FormCreate(Sender: TObject);
begin
  Tentativas := 0; // Inicia o contador de tentativas frustradas de login
end;

end.
