unit uPrincipal;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.Menus, Vcl.ImgList, System.Actions,
  Vcl.ActnList, System.StrUtils, Data.SqlExpr, Data.DB, Vcl.ComCtrls,
  Vcl.ExtCtrls, Vcl.ToolWin;

type
  TfrmPrincipal = class(TForm)
    mmPrincipal: TMainMenu;
    alPrincipal: TActionList;
    ilPrincipal: TImageList;
    actRotinas: TAction;
    actSair: TAction;
    Cadastros1: TMenuItem;
    Clientes1: TMenuItem;
    Configuraes1: TMenuItem;
    GeraTabelasdeRotinas1: TMenuItem;
    Sair1: TMenuItem;
    actGrpAcesso: TAction;
    GruposdeAcesso1: TMenuItem;
    actUsuarios: TAction;
    CadastrodeUsurios1: TMenuItem;
    tbPrincipal: TToolBar;
    pUsuario: TPanel;
    ToolButton1: TToolButton;
    actRamos: TAction;
    actClientes: TAction;
    RamosdeAtividade1: TMenuItem;
    ToolButton2: TToolButton;
    tbsepCadastros: TToolButton;
    ToolButton4: TToolButton;
    tbsepConfiguracoes: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    procedure actRotinasExecute(Sender: TObject);
    procedure actSairExecute(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure actGrpAcessoExecute(Sender: TObject);
    procedure actUsuariosExecute(Sender: TObject);
    procedure actRamosExecute(Sender: TObject);
    procedure actClientesExecute(Sender: TObject);
  private
    { Private declarations }
    function GeraRotinas : Boolean;
    procedure DefineAcesso(Frm, Action : TObject; ActName : String);
  public
    { Public declarations }
    uCodigo : TIntegerField;  //declare em uses no incio da Unit: Data.DB
    uDescricao : TStringField;  //na prxima parte do artigo abordaremos a
  end;                          //utilizao desses dois objetos

var
  frmPrincipal: TfrmPrincipal;

implementation

{$R *.dfm}

uses udmPrincipal, uCads, uGrpAcesso, uUsuarios, uRamos, uClientes;

{ TfrmPrincipal }

procedure TfrmPrincipal.actClientesExecute(Sender: TObject);
begin
  frmClientes := TfrmClientes.Create(Self);
  Try
    DefineAcesso(frmClientes, Sender, 'actClientes');
    frmClientes.ShowModal;
  Finally
    FreeAndNil(frmClientes);
  End;
end;

procedure TfrmPrincipal.actGrpAcessoExecute(Sender: TObject);
begin
  frmGrpAcesso := TfrmGrpAcesso.Create(Self);
  Try
    DefineAcesso(frmGrpAcesso, Sender, 'actGrpAcesso');
    frmGrpAcesso.ShowModal;
  Finally
    FreeAndNil(frmGrpAcesso);
  End;
end;

procedure TfrmPrincipal.actRamosExecute(Sender: TObject);
begin
  frmRamos := TfrmRamos.Create(Self);
  Try
    DefineAcesso(frmRamos, Sender, 'actRamos');
    frmRamos.ShowModal;
  Finally
    FreeAndNil(frmRamos);
  End;
end;

procedure TfrmPrincipal.actRotinasExecute(Sender: TObject);
begin
  GeraRotinas;
end;

procedure TfrmPrincipal.actSairExecute(Sender: TObject);
begin
  Close;
end;

procedure TfrmPrincipal.actUsuariosExecute(Sender: TObject);
begin
  frmUsuarios := TfrmUsuarios.Create(Self);
  Try
    DefineAcesso(frmUsuarios, Sender, 'actUsuarios');
    frmUsuarios.ShowModal;
  Finally
    FreeAndNil(frmUsuarios);
  End;
end;

procedure TfrmPrincipal.DefineAcesso(Frm, Action: TObject; ActName: String);
begin
  If Action = nil Then
    (Frm as TForm).Tag := 1;
  // Se Action for = 1 significa que estarei utilizando este form apenas para consulta
  // dentro de outro form (vamos utilizar este recurso no cadastro de Usurios).
  If dmPrincipal.cdsAcesso.FindKey([ActName]) Then
  Begin
    (Frm as TfrmCads).uIncluir := dmPrincipal.cdsAcessoincluir.AsString;
    (Frm as TfrmCads).uAlterar := dmPrincipal.cdsAcessoalterar.AsString;
    (Frm as TfrmCads).uExcluir := dmPrincipal.cdsAcessoexcluir.AsString;
    (Frm as TfrmCads).dsCadsStateChange(nil);
    If Action = nil Then
    Begin
      (Frm as TfrmCads).uCodigo := uCodigo;
      (Frm as TfrmCads).uDescricao := uDescricao;
  // temos que referenciar no form que ser utilizado para consulta os dois campos
  // que vem do form que estar chamando o form para consulta.
    End;
  End;
end;

procedure TfrmPrincipal.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  dmPrincipal.FechaBanco;
  Application.Terminate;
end;

procedure TfrmPrincipal.FormCreate(Sender: TObject);
var
  wLoop : Integer;
  wNivel1, wNivel2, wNivel3 : Integer;
  bNivel2, bNivel3 : Boolean;
begin
  dmPrincipal.cdsAcesso.Close;
  dmPrincipal.cdsAcesso.Params[0].AsInteger := dmPrincipal.cdsLogingrupo_acesso.AsInteger;
  dmPrincipal.cdsAcesso.Open;
  // Se for o primeira execuo do aplicativo executa a funo GeraRotinas
  If dmPrincipal.cdsAcesso.IsEmpty Then Begin
    If not GeraRotinas Then Begin
      Close;
      Exit;
    End;
    dmPrincipal.cdsAcesso.Refresh;
  End;

  // primeiro eu percorro todas as actions
  For wLoop := 0 To alPrincipal.ActionCount - 1 Do Begin
    If dmPrincipal.cdsAcesso.FindKey([alPrincipal.Actions[wLoop].Name]) Then
      TAction(alPrincipal.Actions[wLoop]).Visible := dmPrincipal.cdsAcessoexecutar.AsString = 'S'
    Else
      TAction(alPrincipal.Actions[wLoop]).Visible := False;
    Case alPrincipal.Actions[wLoop].Tag Of
    // se tag = 1 e a action = True, habilita tbsepCadastros para visvel
      1 : If alPrincipal.Actions[wLoop].Visible Then tbsepCadastros.Visible := True;
    // se tag = 2 e a action = True, habilita tbsepConfiguracoes para visvel
      2 : If alPrincipal.Actions[wLoop].Visible Then tbsepConfiguracoes.Visible := True;
    End;
  End;
  // se tem permisso de execuo a action em questo fica visvel caso contrrio vica invisvel
  // como os intens do menu so atrelados as actions, eles sofrem o resultado.

  // como o menu funciona em at trs nveis, verifico se os nveis superiores
  // que no tem action, ou seja, no executam nada na aplicao, para ver se
  // tem sub-itens ativos, caso contrrio deixo invisvel.
        // primeiro nvel
  For wNivel1 := 0 To mmPrincipal.Items.Count - 1 Do Begin
    bNivel2 := False;
        // segundo nvel
    For wNivel2 := 0 To mmPrincipal.Items[wNivel1].Count - 1 Do Begin
      If mmPrincipal.Items[wNivel1].Items[wNivel2].Caption = '-' Then Continue;
      bNivel3 := False;
        // terceiro nvel
      For wNivel3 := 0 To mmPrincipal.Items[wNivel1].Items[wNivel2].Count - 1 Do Begin
        If mmPrincipal.Items[wNivel1].Items[wNivel2].Items[wNivel3].Caption = '-' Then Continue;
        If mmPrincipal.Items[wNivel1].Items[wNivel2].Items[wNivel3].Visible Then
          bNivel3 := True;// se existir algum item visvel no 3o nvel
      End;
      // segundo nvel
      If mmPrincipal.Items[wNivel1].Count > 0 Then
        If mmPrincipal.Items[wNivel1].Items[wNivel2].Action = nil Then
          mmPrincipal.Items[wNivel1].Items[wNivel2].Visible := bNivel3; // <-----

      If mmPrincipal.Items[wNivel1].Items[wNivel2].Visible Then
        bNivel2 := True;  // se exister algum item visvel no 2o nvel
    End;
    // primeiro nvel
    If mmPrincipal.Items[wNivel1].Action = nil Then
      mmPrincipal.Items[wNivel1].Visible := bNivel2; // <-----
  End;
end;

function TfrmPrincipal.GeraRotinas : Boolean;
var
  wNivel1, wNivel2, wNivel3, wOrdem : Integer;
  wSQLr, wSQLsu, Texto, wAction : String;
  wMItem : TMenuItem;
  TD : TTransactionDesc;  // declare no primeiro uses Data.SqlExpr
begin
  Result := True;
  If MessageDlg('Tem certeza que deseja executar esta Rotina???', mtConfirmation,
                [mbNo,mbYes], 0, mbNo) = mrNo Then Begin
    Result := False;
    Exit;
  End;

  wSQLr := 'insert into rotinas values ';  // aqui comeo a montar os comandos sql
  wOrdem := 0;
  wAction := '';

  For wNivel1 := 0 To mmPrincipal.Items.Count - 1 Do Begin   // aqui vou verificar cada item do primeiro nvel
    wMItem := mmPrincipal.Items[wNivel1]; // armazeno o item em uma varivel para no ficar muito grande na hora de manipular as informaes do item.
    If wMItem.Caption = '-' Then Continue; // se o item for apenas uma separao pulo o mesmo.
    If wMItem.Action = nil Then // Se neste item no houver action ento
      wAction := ''          // o nome da action  branco
    Else                   // caso contrrio
      wAction := wMItem.Action.Name; // coloco o nome da action na varivel
    Inc(wOrdem); // aqui eu determino qual a ordem de cada item para uso do index da tabela rotinas
    wSQLr := wSQLr +  // aqui eu monto o insert do SQL para primeiro nvel
              '('''+wMItem.Name+''', '+IntToStr(wOrdem)+', '''+
              StringReplace(wMItem.Caption, '&', '', [rfReplaceAll,rfIgnoreCase])+''', '''', '''', '''+
              IfThen(wMItem.Action=nil,'N','S')+''', '''+wAction+'''), ';
          // declare System.StrUtils no primeiro uses
    For wNivel2 := 0 To mmPrincipal.Items[wNivel1].Count - 1 Do Begin // itens do segundo nvel
      wMItem := mmPrincipal.Items[wNivel1].Items[wNivel2];
      If wMItem.Caption = '-' Then Continue;
      If wMItem.Action = nil Then
        wAction := ''
      Else
        wAction := wMItem.Action.Name;
      Inc(wOrdem);
      wSQLr := wSQLr +  // insert do SQL para o segundo nvel
                '('''+wMItem.Name+''', '+IntToStr(wOrdem)+', '''', '''+
                StringReplace(wMItem.Caption, '&', '', [rfReplaceAll,rfIgnoreCase])+''', '''', '''+
                IfThen(wMItem.Action=nil,'N','S')+''', '''+wAction+'''), ';
                     // itens do terceiro nvel
      For wNivel3 := 0 To mmPrincipal.Items[wNivel1].Items[wNivel2].Count - 1 Do Begin
        wMItem := mmPrincipal.Items[wNivel1].Items[wNivel2].Items[wNivel3];
        If wMItem.Caption = '-' Then Continue;
        If wMItem.Action = nil Then
          wAction := ''
        Else
          wAction := wMItem.Action.Name;
        Inc(wOrdem);
        wSQLr := wSQLr +  // insert do SQL para o terceiro nvel
                  '('''+wMItem.Name+''', '+IntToStr(wOrdem)+', '''', '''', '''+
                  StringReplace(wMItem.Caption, '&', '', [rfReplaceAll,rfIgnoreCase])+''', '''+
                  IfThen(wMItem.Action=nil,'N','S')+''', '''+wAction+'''), ';
      End;
    End;
  End;

  wSQLr := LeftStr(wSQLr, Length(wSQLr)-2)+'; '; // substituo a ltima vrgula por um ponto e vrgula.
        // aqui eu insiro em acesso_rots todos os direitos para o SuperUsurio.
  wSQLsu := 'insert into acesso_rots (grupo_acesso, rotina, executar, incluir, alterar, excluir) '+
            'select '+
              '0, nome_item_menu, ''S'', ''S'', ''S'', ''S'''+
            'from '+
              'rotinas ';

  Try
    TD.TransactionID := 1;     // configuro uma transao SQL
    TD.IsolationLevel := xilREPEATABLEREAD;
    dmPrincipal.sqlcEmpresa.StartTransaction(TD);  // inicio a transao SQL
  // aqui comeo a executar os comandos sql: primeiro, limpar a tabela rotinas.
    dmPrincipal.sqlcEmpresa.ExecuteDirect('truncate rotinas');
  // segundo, inserir as configuraes das opes do mmPrincipal
    dmPrincipal.sqlcEmpresa.ExecuteDirect(wSQLr);
  // terceiro, apagar os direitos do SuperUsurio.
    dmPrincipal.sqlcEmpresa.ExecuteDirect('delete from acesso_rots where grupo_acesso=0');
  // quarto e ltimo reinserir os direitos do SuperUsurio para as novas rotinas
    dmPrincipal.sqlcEmpresa.ExecuteDirect(wSQLsu);
  // se todos os sqls no derem problema, confirmo-os (Commit)
    dmPrincipal.sqlcEmpresa.Commit(TD);
    MessageDlg('Rotina realizada!!!', mtInformation, [mbOK], 0);
  Except
  // Se em algum dos sqls apresentar problema, cancelo todos os anteriores (Rollback)
    dmPrincipal.sqlcEmpresa.Rollback(TD);
    MessageDlg('Erro ao Executar Rotina!!!', mtError, [mbOK], 0);
    Result := False;
  End;
end;

end.
