unit udmPrincipal;

interface

uses
  System.SysUtils, System.Classes, Data.DBXMySQL, Data.DB, Data.SqlExpr,
  Data.FMTBcd, Datasnap.DBClient, Datasnap.Provider, Vcl.Dialogs, Vcl.Forms,
  Datasnap.Win.TConnect;

type
  TdmPrincipal = class(TDataModule)
    sqlcEmpresa: TSQLConnection;
    sdsLogin: TSQLDataSet;
    dspLogin: TDataSetProvider;
    cdsLogin: TClientDataSet;
    dspCodigos: TDataSetProvider;
    cdsCodigos: TClientDataSet;
    sdsCodigos: TSQLDataSet;
    cdsLogincodigo: TIntegerField;
    cdsLoginusuario: TStringField;
    cdsLoginsenha: TStringField;
    cdsLoginnome: TStringField;
    cdsLogingrupo_acesso: TIntegerField;
    cdsLoginativo: TStringField;
    cdsCodigosdescricao: TStringField;
    cdsCodigosvalor: TIntegerField;
    sdsAcesso: TSQLDataSet;
    dspAcesso: TDataSetProvider;
    cdsAcesso: TClientDataSet;
    cdsAcessogrupo_acesso: TIntegerField;
    cdsAcessorotina: TStringField;
    cdsAcessoexecutar: TStringField;
    cdsAcessoincluir: TStringField;
    cdsAcessoalterar: TStringField;
    cdsAcessoexcluir: TStringField;
    cdsAcessonome_action: TStringField;
    sdsGrpAcesso: TSQLDataSet;
    dspGrpAcesso: TDataSetProvider;
    sdsGrpAcessocodigo: TIntegerField;
    sdsGrpAcessodescricao: TStringField;
    lcPrincipal: TLocalConnection;
    sdsDefAcesso: TSQLDataSet;
    dspDefAcesso: TDataSetProvider;
    sdsDefAcessogrupo_acesso: TIntegerField;
    sdsDefAcessorotina: TStringField;
    sdsDefAcessonivel1: TStringField;
    sdsDefAcessonivel2: TStringField;
    sdsDefAcessonivel3: TStringField;
    sdsDefAcessoaction: TStringField;
    sdsDefAcessoexecutar: TStringField;
    sdsDefAcessoincluir: TStringField;
    sdsDefAcessoalterar: TStringField;
    sdsDefAcessoexcluir: TStringField;
    sdsUsuarios: TSQLDataSet;
    dspUsuarios: TDataSetProvider;
    sdsUsuarioscodigo: TIntegerField;
    sdsUsuariosusuario: TStringField;
    sdsUsuariossenha: TStringField;
    sdsUsuariosconfsenha: TStringField;
    sdsUsuariosnome: TStringField;
    sdsUsuariosgrupo_acesso: TIntegerField;
    sdsUsuariosdesc_grp: TStringField;
    sdsUsuariosativo: TStringField;
    sdsRamos: TSQLDataSet;
    dspRamos: TDataSetProvider;
    sdsRamoscodigo: TIntegerField;
    sdsRamosdescricao: TStringField;
    sdsClientes: TSQLDataSet;
    dspClientes: TDataSetProvider;
    sdsClientescodigo: TIntegerField;
    sdsClientesdescricao: TStringField;
    sdsClientesendereco: TStringField;
    sdsClientescomplemento: TStringField;
    sdsClientesbairro: TStringField;
    sdsClientescidade: TStringField;
    sdsClientesuf: TStringField;
    sdsClientescep: TStringField;
    sdsClientestelefone: TStringField;
    sdsClientesramo: TIntegerField;
    sdsClientesdesc_ramos: TStringField;
    procedure DataModuleCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    function RetornaID(KeyName: String) : Integer;
    procedure FechaBanco;
    procedure ValidaDataSet(cds : TClientDataSet);
    procedure Pes(vCodigo : TIntegerField; vDesc : TStringField; vTabela : String);
  end;

var
  dmPrincipal: TdmPrincipal;

implementation

{%CLASSGROUP 'Vcl.Controls.TControl'}

uses uLogin;

{$R *.dfm}

{ TdmPrincipal }

procedure TdmPrincipal.DataModuleCreate(Sender: TObject);
begin
  Try
    sqlcEmpresa.Open;
  Except     // declare Vcl.Dialogs em uses (no incio do cdigo)
    MessageDlg('Erro ao Conectar ao Banco de Dados!!!', mtError, [mbOK], 0);
    Application.Terminate; // declare Vcl.Forms em uses (no incio do cdigo)
  End;

  frmLogin := TfrmLogin.Create(Self);

  Try
    frmLogin.ShowModal;
  Except
    MessageDlg('Problemas ao fazer login!!!', mtError, [mbOK], 0);
    FechaBanco;
    frmLogin.Tag := 0;
  End;
end;

procedure TdmPrincipal.FechaBanco;
var i : Integer;
begin
  For i := 0 To ComponentCount - 1 Do
    If Components[i] is TClientDataSet Then //fecha todos os ClientDataSet que estiverem em dmPrincipal
      (Components[i] as TClientDataSet).Close;

  sqlcEmpresa.Close;
end;

procedure TdmPrincipal.Pes(vCodigo: TIntegerField; vDesc: TStringField;
  vTabela: String);
var
  sdsTemp : TSQLDataSet;
begin
  If vCodigo.AsString = '' Then
  Begin
    vDesc.AsString := '';
    Exit;
  End;
  sdsTemp := TSQLDataSet.Create(Self);
  sdsTemp.SQLConnection := sqlcEmpresa;
  sdsTemp.CommandText := 'select descricao from '+vTabela+' where codigo='+vCodigo.Text;
  sdsTemp.Open;

  If sdsTemp.IsEmpty Then
  Begin
    vCodigo.Clear;
    vDesc.Clear;
  End
  Else
    vDesc.AsString := sdsTemp.FieldByName('descricao').AsString;
  FreeAndNil(sdsTemp);
end;

function TdmPrincipal.RetornaID(KeyName: String): Integer;
begin
  Try
    Repeat
      cdsCodigos.Close;
      cdsCodigos.Params[0].AsString := UpperCase(KeyName);
      cdsCodigos.Open;
      If cdsCodigos.RecordCount = 1 Then Begin
        cdsCodigos.Edit;
        cdsCodigosvalor.AsInteger := cdsCodigosvalor.AsInteger + 1;
      End Else
        If cdsCodigos.RecordCount <= 0 Then Begin
          cdsCodigos.Insert;
          cdsCodigosdescricao.AsString := UpperCase(KeyName);
          cdsCodigosvalor.AsInteger := 1;
        End;
      cdsCodigos.Post;
    Until
      (cdsCodigos.ApplyUpdates(0) = 0);

    Result := cdsCodigosvalor.AsInteger;
  Except
    Result := -1;
  End;
  cdsCodigos.Close;
end;

procedure TdmPrincipal.ValidaDataSet(cds: TClientDataSet);
var wFields : Integer;
begin
  For wFields := 0 to cds.FieldList.Count - 1 Do
  Begin
    If (cds.Fields[wFields].Required) and (Trim(cds.Fields[wFields].Text) = '') Then
    Begin
      MessageDlg(Format('O Campo "%s"  Obrigatrio!!!',
        [cds.Fields[wFields].DisplayName]), mtWarning, [mbOK], 0);
      cds.Fields[wFields].FocusControl;
      Abort;
    End;
  End;
end;

end.
